config/routes.rb
  mount API::Root => "/api"

  # OAuth authorization routes
  use_doorkeeper do
    # Do not add global application controller
    skip_controllers :applications, :authorized_applications
  end

  get "/roles/workflow/:id/:role_id/:type_id" => "roles#workflow"

  get "/types/:id/edit/:tab" => "types#edit",
      as: "edit_type_tab"
  match "/types/:id/update/:tab" => "types#update",
        as: "update_type_tab",
        via: %i[post patch]
  resources :types do
    post "move/:id", action: "move", on: :collection
  end

  resources :statuses, except: :show

  get "custom_style/:digest/logo/:filename" => "custom_styles#logo_download",
      as: "custom_style_logo",
      constraints: { filename: /[^\/]*/ }

  get "custom_style/:digest/export_logo/:filename" => "custom_styles#export_logo_download",
      as: "custom_style_export_logo",
      constraints: { filename: /[^\/]*/ }

  get "custom_style/:digest/export_cover/:filename" => "custom_styles#export_cover_download",
      as: "custom_style_export_cover",
      constraints: { filename: /[^\/]*/ }

  get "custom_style/:digest/favicon/:filename" => "custom_styles#favicon_download",
      as: "custom_style_favicon",
      constraints: { filename: /[^\/]*/ }

  get "custom_style/:digest/touch-icon/:filename" => "custom_styles#touch_icon_download",
      as: "custom_style_touch_icon",
      constraints: { filename: /[^\/]*/ }

  get "highlighting/styles(/:version_tag)" => "highlighting#styles",
      as: "highlighting_css_styles"

  resources :custom_fields, except: :show do
    member do
      delete "options/:option_id", to: "custom_fields#delete_option", as: :delete_option_of

      post :reorder_alphabetical
    end
  end

  get "(projects/:project_id)/search" => "search#index", as: "search"

  # only providing routes for journals when there are multiple subclasses of journals
  # all subclasses will look for the journals routes
  resources :journals, only: :index do
    get "diff/:field", action: :diff, on: :member, as: "diff"
  end

  # REVIEW: review those wiki routes
  scope "projects/:project_id/wiki/:id" do
    resource :wiki_menu_item, only: %i[edit update]
  end

  # generic route for adding/removing watchers
  scope ":object_type/:object_id", constraints: OpenProject::Acts::Watchable::Routes do
    post "/watch" => "watchers#watch"
    delete "/unwatch" => "watchers#unwatch"
  end

  # generic route for adding/removing favorites
  scope ":object_type/:object_id", constraints: OpenProject::Acts::Favorable::Routes do
    post "/favorite" => "favorites#favorite"
    delete "/favorite" => "favorites#unfavorite"
  end

  namespace :projects do
    resource :menu, only: %i[show]
    resources :queries, only: %i[new create destroy]
  end

  resources :projects, except: %i[show edit create update] do
    scope module: "projects" do
      namespace "settings" do
        resource :general, only: %i[show], controller: "general"
        resource :modules, only: %i[show update]
        resource :types, only: %i[show update]
        resource :project_custom_fields, only: %i[show] do
          member do
            post :toggle
          end
          collection do
            put :enable_all_of_section
            put :disable_all_of_section
          end
        end
        resource :custom_fields, only: %i[show update]
        resource :repository, only: %i[show], controller: "repository"
        resource :versions, only: %i[show]
        resource :categories, only: %i[show update]
        resource :storage, only: %i[show], controller: "storage"
      end

      resource :templated, only: %i[create destroy], controller: "templated"
      resource :archive, only: %i[create destroy], controller: "archive"
      resource :identifier, only: %i[show update], controller: "identifier"
    end

    member do
      get "settings", to: redirect("projects/%{id}/settings/general/")

      get :copy

      patch :types

      # Destroy uses a get request to prompt the user before the actual DELETE request
      get :destroy_info, as: "confirm_destroy"
    end

    resources :versions, only: %i[new create] do
      collection do
        put :close_completed
      end
    end

    # this is only another name for versions#index
    # For nice "road in the url for the index action
    # this could probably be rewritten with a resource as: 'roadmap'
    get "/roadmap" => "versions#index"

    resources :news, only: %i[index new create]

    # Match everything to be the ID of the wiki page except the part that
    # is reserved for the format. This assumes that we have only two formats:
    # .txt and .html
    resources :wiki,
              constraints: { id: /([^\/]+(?=\.markdown)|[^\/]+)/ },
              except: %i[index create] do
      collection do
        post "/new" => "wiki#create", as: "create"
        get :export
        get "/index" => "wiki#index"
        get :menu
      end

      member do
        get "/new" => "wiki#new_child", as: "new_child"
        get "/diff/:version/vs/:version_from" => "wiki#diff", as: "wiki_diff_compare"
        get "/diff(/:version)" => "wiki#diff", as: "wiki_diff"
        get "/annotate/:version" => "wiki#annotate", as: "wiki_annotate"
        get "/toc" => "wiki#index"
        match :rename, via: %i[get patch]
        get :parent_page, action: "edit_parent_page"
        patch :parent_page, action: "update_parent_page"
        get :history
        post :protect
        get :select_main_menu_item, to: "wiki_menu_items#select_main_menu_item"
        post :replace_main_menu_item, to: "wiki_menu_items#replace_main_menu_item"
        get :menu
      end
    end

    # as routes for index and show are swapped
    # it is necessary to define the show action later
    # than any other route as it otherwise would
    # work as a catchall for everything under /wiki
    get "wiki" => "wiki#show"

    resources :work_packages, only: [] do
      collection do
        get "/report/:detail" => "work_packages/reports#report_details"
        get "/report" => "work_packages/reports#report"
      end

      # states managed by client-side routing on work_package#index
      get "(/*state)" => "work_packages#index", on: :collection, as: ""
      get "/create_new" => "work_packages#index", on: :collection, as: "new_split"
      get "/new" => "work_packages#index", on: :collection, as: "new"

      # state for show view in project context
      get "(/*state)" => "work_packages#show", on: :member, as: ""
    end

    resources :activity, :activities, only: :index, controller: "activities" do
      collection do
        get :menu
      end
    end

    resources :forums do
      member do
        get :confirm_destroy
        get :move
        post :move
      end
    end

    resources :categories, except: %i[index show], shallow: true

    resources :members, only: %i[index create update], shallow: true do
      collection do
        delete "by_principal/:principal_id", action: :destroy_by_principal

        get :autocomplete_for_member
      end
    end

    namespace :members do
      resource :menu, only: %[show]
    end

    resource :repository, controller: "repositories", except: [:new] do
      # Destroy uses a get request to prompt the user before the actual DELETE request
      get :destroy_info
      get :committers
      post :committers
      get :graph
      get :revisions

      get "/statistics", action: :stats, as: "stats"

      get "(/revisions/:rev)/diff.:format", action: :diff
      get "(/revisions/:rev)/diff(/*repo_path)",
          action: :diff,
          format: "html",
          constraints: { rev: /[\w.\-]+/, repo_path: /.*/ }

      get "(/revisions/:rev)/:format/*repo_path",
          action: :entry,
          format: /raw/,
          rev: /[\w.\-]+/

      %w{diff annotate changes entry browse}.each do |action|
        get "(/revisions/:rev)/#{action}(/*repo_path)",
            format: "html",
            action:,
            constraints: { rev: /[\w.\-]+/, repo_path: /.*/ },
            as: "#{action}_revision"
      end

      get "/revision(/:rev)", rev: /[\w.\-]+/,
                              action: :revision,
                              as: "show_revision"

      get "(/revisions/:rev)(/*repo_path)",
          action: :show,
          format: "html",
          constraints: { rev: /[\w.\-]+/, repo_path: /.*/ },
          as: "show_revisions_path"
    end
  end

  resources :admin, controller: :admin, only: :index do
    collection do
      get :plugins
      get :info
      post :test_email
    end
  end

  scope "admin" do
    resource :announcements, only: %i[edit update]
    resources :enumerations do
      post "move/:id", action: "move", on: :collection
    end

    delete "design/logo" => "custom_styles#logo_delete", as: "custom_style_logo_delete"
    delete "design/export_logo" => "custom_styles#export_logo_delete", as: "custom_style_export_logo_delete"
    delete "design/export_cover" => "custom_styles#export_cover_delete", as: "custom_style_export_cover_delete"
    delete "design/favicon" => "custom_styles#favicon_delete", as: "custom_style_favicon_delete"
    delete "design/touch_icon" => "custom_styles#touch_icon_delete", as: "custom_style_touch_icon_delete"
    post "design/colors" => "custom_styles#update_colors", as: "update_design_colors"
    post "design/themes" => "custom_styles#update_themes", as: "update_design_themes"
    post "design/export_cover_text_color" => "custom_styles#update_export_cover_text_color",
         as: "update_custom_style_export_cover_text_color"

    resource :custom_style, only: %i[update show create], path: "design"

    resources :attribute_help_texts, only: %i[index new create edit update destroy]

    resources :groups, except: %i[show] do
      member do
        # this should be put into it's own resource
        post "/members" => "groups#add_users", as: "members_of"
        delete "/members/:user_id" => "groups#remove_user", as: "member_of"

app/models/repository/git.rb
#-- copyright
# Nepenthes is a free and open project management software.
# Copyright (C) 2024 The Nirvati developers
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# Nepenthes is a fork of OpenProject. The copyright follows:
#
# Copyright (C) 2012-2024 the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

require "open_project/scm/adapters/git"

class Repository::Git < Repository
  validates :url, presence: true
  validate :validity_of_local_url

  def self.scm_adapter_class
    OpenProject::SCM::Adapters::Git
  end

  def configure(scm_type, _args)
    if scm_type == self.class.managed_type
      unless manageable?
        raise OpenProject::SCM::Exceptions::RepositoryBuildError.new(
          I18n.t("repositories.managed.error_not_manageable")
        )
      end

      self.root_url = managed_repository_path
      self.url = managed_repository_url
    end
  end

  def self.permitted_params(params)
    super(params).merge(params.permit(:path_encoding))
  end

  def self.supported_types
    types = [:local]
    types << managed_type if manageable?

    types
  end

  def managed_repo_created
    scm.initialize_bare_git
  end

  def repository_identifier
    "#{super}.git"
  end

  def repository_type
    "Git"
  end

  ##
  # Git doesn't like local urls when visiting
  # the repository, thus always use the path.
  def managed_repository_url
    managed_repository_path
  end

  def supports_directory_revisions?
    true
  end

  def repo_log_encoding
    "UTF-8"
  end

  def self.authorization_policy
    ::SCM::GitAuthorizationPolicy
  end

  # Returns the identifier for the given git changeset
  def self.changeset_identifier(changeset)
    changeset.scmid
  end

  # Returns the readable identifier for the given git changeset
  def self.format_changeset_identifier(changeset)
    format_revision(changeset.revision)
  end

  def self.format_revision(revision)
    revision[0, 8]
  end

  delegate :branches, to: :scm

  delegate :tags, to: :scm

  def find_changeset_by_name(name)
    return nil if name.nil? || name.empty?

    e = changesets.where(["revision = ?", name.to_s]).first
    return e if e

    changesets.where(["scmid LIKE ?", "#{name}%"]).first
  end

  # With SCM's that have a sequential commit numbering, redmine is able to be
  # clever and only fetch changesets going forward from the most recent one
  # it knows about.  However, with git, you never know if people have merged
  # commits into the middle of the repository history, so we should parse
  # the entire log. Since it's way too slow for large repositories, we only
  # parse 1 week before the last known commit.
  # The repository can still be fully reloaded by calling #clear_changesets
  # before fetching changesets (eg. for offline resync)
  def fetch_changesets
    c = changesets.order(Arel.sql("committed_on DESC")).first
    since = (c ? c.committed_on - 7.days : nil)

    revisions = scm.revisions("", nil, nil, all: true, since:, reverse: true)
    return if revisions.nil? || revisions.empty?

    recent_changesets = changesets.where(["committed_on >= ?", since])

    # Clean out revisions that are no longer in git
    recent_changesets.each { |c| c.destroy unless revisions.detect { |r| r.scmid.to_s == c.scmid.to_s } }

    # Subtract revisions that redmine already knows about
    recent_revisions = recent_changesets.map(&:scmid)
    revisions.reject! { |r| recent_revisions.include?(r.scmid) }

    # Save the remaining ones to the database
    unless revisions.nil?
      revisions.each do |rev|
        transaction do
          changeset = Changeset.new(
            repository: self,
            revision: rev.identifier,
            scmid: rev.scmid,
            committer: rev.author,
            committed_on: rev.time,
            comments: rev.message
          )

          if changeset.save
            rev.paths.each do |file|
              Change.create(
                changeset:,
                action: file[:action],
                path: file[:path]
              )
            end
          end
        end
      end
    end
  end

  def latest_changesets(path, rev, limit = 10)
    revisions = scm.revisions(path, nil, rev, limit:, all: false)
    return [] if revisions.nil? || revisions.empty?

    changesets.where(["scmid IN (?)", revisions.map!(&:scmid)])
      .order(Arel.sql("committed_on DESC"))
  end

  private

  def validity_of_local_url
    parsed = URI.parse root_url.presence || url
    if parsed.scheme == "ssh"
      errors.add :url, :must_not_be_ssh
    end
  rescue StandardError => e
    Rails.logger.error "Failed to parse repository url for validation: #{e}"
    errors.add :url, :invalid_url
  end
end

app/controllers/projects/settings/repository_controller.rb
#-- copyright
# Nepenthes is a free and open project management software.
# Copyright (C) 2024 The Nirvati developers
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# Nepenthes is a fork of OpenProject. The copyright follows:
#
# Copyright (C) 2012-2024 the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

class Projects::Settings::RepositoryController < Projects::SettingsController
  menu_item :settings_repository

  def show
    @repository = @project.repository || new_repository
  end

  private

  def new_repository
    return unless params[:scm_vendor]

    service = SCM::RepositoryFactoryService.new(@project, params)
    if service.build_temporary
      @repository = service.repository
    else
      logger.error("Cannot create repository for #{params[:scm_vendor]}")
      flash[:error] = service.build_error
      nil
    end
  end
end

app/views/repositories/_repository_header.html.erb
<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<persistent-toggle data-identifier="repository.checkout_instructions"></persistent-toggle>
<%= toolbar title: t('repositories.named_repository',
                     vendor_name: @repository.class.vendor_name) do %>
  <% if @instructions && @instructions.available? %>
  <li class="toolbar-item toolbar-input-group hidden-for-mobile">
    <div class="toolbar-input-group--affix -prepend">
      <span><%= @instructions.checkout_command %></span>
    </div>
    <input id="repository-checkout-url"
           type="text" class="-clickable" size="40"
           value="<%= @instructions.checkout_url(true) %>"
           readonly>
    <% csp_onclick('this.focus(); this.select();', '#repository-checkout-url') %>
    <copy-to-clipboard click-target=".repository-checkout-copy-button"
                       clipboard-target="#repository-checkout-url">
    </copy-to-clipboard>
    <button class="repository-checkout-copy-button toolbar-input--affix toolbar-input-group--affix -append"
            title="<%= t(:button_copy_to_clipboard) %>">
      <%= op_icon('icon-copy') %>
      <span class="hidden-for-sighted"><%= t(:button_copy_to_clipboard) %></span>
    </button>
  </li>
  <li class="toolbar-item -icon-only">
    <a id="repository--checkout-instructions-toggle"
       class="persistent-toggle--click-handler button"
       title="<%= t('repositories.checkout.show_instructions') %>">
      <%= op_icon('button--icon icon-info1') %>
    </a>
  </li>
  <% end %>
  <% if !empty && User.current.allowed_in_project?(:browse_repository, @project) %>
  <li class="toolbar-item -icon-only">
    <%= link_to stats_project_repository_path(@project),
        class: 'button', title: t(:label_statistics) do %>
      <%= op_icon('button--icon icon-chart1') %>
    <% end %>
  </li>
  <% end %>
  <%= call_hook(:repositories_navigation_toolbar,
                { repository: @repository, project: @project, repository_empty: empty }) %>
  <% if User.current.allowed_in_project?(:manage_repository, @project) %>
    <li class="toolbar-item -icon-only">
      <%= link_to project_settings_repository_path(@project),
          class: 'button', title: t(:label_setting_plural) do %>
        <%= op_icon('button--icon icon-settings') %>
      <% end %>
    </li>
  <% end %>
<% end %>


<% if @instructions %>
  <%= render partial: 'checkout_instructions',
             locals: { repository: @repository, instructions: @instructions } %>
<% end %>

app/views/repositories/destroy_info.html.erb
<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>
<% if @repository.managed? %>
  <%= styled_form_tag(project_repository_path(@project), method: :delete, class: 'danger-zone') do %>
    <section class="form--section">
      <h3 class="form--section-title">
        <%= t('repositories.destroy.title', repository_type: "<em>#{h(@repository.repository_type)} - #{t(:project_module_repository)}</em>").html_safe %>
      </h3>
      <p>
        <%= t('repositories.destroy.subtitle', repository_type: "#{h(@repository.repository_type)} - #{t(:project_module_repository)}", project_name: h(@project.identifier)).html_safe %> <br />
        <%= t('repositories.destroy.confirmation') %>
        <br/>
        <%= t('repositories.destroy.managed_path_note', path: @repository.root_url) %>
      </p>
      <p class="danger-zone--warning">
        <span class="icon icon-error"></span>
        <span><%= t('repositories.destroy.info') %></span>
      </p>
      <p>
        <%= t('repositories.destroy.repository_verification', identifier: "<em class=\"danger-zone--expected-value\">#{h(@project.identifier)}</em>").html_safe %>
      </p>
      <div class="danger-zone--verification">
        <input type="text"></input>
        <%= styled_button_tag project_repository_path(@project),
          method: :delete,
          title: t(:button_delete),
          disabled: true,
          class: '-primary' do %>
            <%= op_icon('button--icon icon-delete') %>
            <span class="button--text"><%= t(:button_delete) %></span>
        <% end %>
        <%= link_to project_settings_repository_path(@project),
          title: t(:button_cancel),
          class: 'button -with-icon icon-cancel' do %>
            <%= t(:button_cancel) %>
        <% end %>
      </div>
    </section>
  <% end %>
<% else %>
  <div class="op-toast -warning">
    <div class="op-toast--content">
      <p><strong><%= t('repositories.destroy.title_not_managed', repository_type: "<em>#{h(@repository.repository_type)} - #{t(:project_module_repository)}</em>").html_safe %></strong><br /></p>
      <p>
        <%= t('repositories.destroy.subtitle_not_managed',
            repository_type: "#{h(@repository.repository_type)} - #{t(:project_module_repository)}",
            project_name: h(@project.identifier),
            url: h(@repository.url)).html_safe %> <br />
      </p>
      <p>
        <span><%= t('repositories.destroy.info_not_managed') %></span>
      </p>
      <p>
        <%= link_to project_repository_path(@project),
          title: t(:button_delete),
          method: :delete,
          class: 'button' do %>
          <%= op_icon('button--icon icon-remove') %>
          <span class="button--text"><%= t(:button_remove) %></span>
        <% end %>
        <%= link_to project_settings_repository_path(@project),
          title: t(:button_cancel),
          class: 'button -with-icon icon-cancel' do %>
            <%= t(:button_cancel) %>
        <% end %>
      </p>
    </div>
  </div>
<% end %>

app/views/repositories/show.html.erb
<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<% content_controller 'repository-navigation', dynamic: true %>
<%= render partial: 'repository_header', locals: { empty: false } %>

<div class="repository-breadcrumbs">
  <%= render partial: 'breadcrumbs',
             locals: { path: @path, revision: @rev }.merge(kind: 'dir') %>
</div>

<% if !@entries.nil? && authorize_for('repositories', 'browse') %>
  <%= render partial: 'dir_list' %>
<% end %>

<%= render_properties(@properties) %>

<%= toolbar title: t(:label_revision_plural), html: { class: 'repository--revision-toolbar' } do %>
  <%# rev => nil prevents overwriting the rev parameter queried for in the form with the parameter from the request %>
  <%= form_tag({ action: controller.action_name,
                 project_id: @project,
                 path: to_path_param(@path),
                 rev: nil
               },
               method: :get,
               id: 'revision_selector',
               class: 'form -vertical',
               data: {
                 'repository-navigation-target': 'form',
               }
      ) do %>
    <li class="toolbar-item toolbar-input-group hidden-for-mobile">
      <div>
        <%= label_tag 'rev', I18n.t('repositories.go_to_revision') %>
      </div>
      <%= text_field_tag :rev,
                         @rev,
                         id: 'revision-identifier-input',
                         placeholder: t(:label_revision),
                         data: {
                           'repository-navigation-target': 'revision',
                           action: 'keydown.enter->repository-navigation#sendForm'
                         } %>
    </li>
    <% if !@repository.branches.nil? && @repository.branches.length > 0 %>
      <li class="toolbar-item toolbar-input-group hidden-for-mobile">
        <div>
          <%= label_tag 'branch', I18n.t(:label_branch) %>
        </div>
        <%= select_tag :branch,
                       options_for_select(@repository.branches, @rev),
                       include_blank: "--- #{t(:actionview_instancetag_blank_option)} ---",
                       id: 'revision-branch-select',
                       data: {
                         'repository-navigation-target': 'branch',
                         action: 'repository-navigation#applyValue'
                       }
        %>
      </li>
    <% end %>
    <% if !@repository.tags.nil? && @repository.tags.length > 0 %>
      <li class="toolbar-item toolbar-input-group hidden-for-mobile">
        <div>
          <%= label_tag 'tag', I18n.t(:label_tag) %>
        </div>
        <%= select_tag :tag,
                       options_for_select(@repository.tags, @rev),
                       include_blank: "--- #{t(:actionview_instancetag_blank_option)} ---",
                       id: 'revision-tag-select',
                       data: {
                         'repository-navigation-target': 'tag',
                         action: 'repository-navigation#applyValue'
                       }
        %>
      </li>
    <% end %>
    <li class="toolbar-item -icon-only">
      <%= link_to({ url: { action: 'revision#revision-identifier-inputs', project_id: @project,
                           key: User.current.rss_key } },
                  { class: 'button', title: t('repositories.atom_revision_feed') }) do %>
        <%= op_icon('button--icon icon-export-atom') %>
      <% end %>
    </li>
  <% end %>
<% end %>

<% if authorize_for('repositories', 'revisions') %>
  <% if @changesets && !@changesets.empty? %>
    <%= render partial: 'revisions',
               locals: { project: @project, path: @path,
                         revisions: @changesets, entry: nil } %>
  <% end %>
  <p>
    <%
      has_branches = (!@repository.branches.nil? && @repository.branches.length > 0)
      sep = ''
    %>

    <% if @repository.supports_all_revisions? && @path.blank? %>
      <%= link_to t(:label_view_all_revisions), revisions_project_repository_path(@project) %>
      <% sep = '|' %>
    <% end %>
  </p>
<% end %>

<% html_title(t(:label_repository)) -%>